/*
 * Created on 2005/03/28
 */
package net.asukaze.anxious;

import java.io.FileNotFoundException;
import java.util.*;

/**
 * Anxious̊{@\܂B
 * @author asukaze
 */
public class Manager {
	private static Random rnd = new Random();
	private boolean studying = false;
	Problem[] unsolvedData = null;
	int unsolvedPos = 0;
	ArrayList historyData = null;
	int historyPos = 0;
	boolean isInHistory = false;
	ArrayList retryData = null;
	String fileName = null;
	boolean useFixedOrder;
	int timelimit;
	ArrayList goodCounter = null;
	int goodCount = 0;
	int badCount = 0;
	
	/**
	 * VManagerNX쐬܂B
	 *
	 */
	public Manager(){
		studying = false;
		unsolvedData = null;
	}
	
	/**
	 * wKł邩ǂԂ܂B
	 * t@CJĂAS␳nextProblem()Ăяo܂ł
	 * trueԂ܂B
	 * @return wKȂtrueAłȂfalseB
	 */
	public boolean isStudying(){
		return studying;
	}
	
	String removePath(String filepath){
		String[] arr1 = filepath.split("[/\\\\]");
		return arr1[arr1.length-1];
	}
	
	/**
	 * t@CJ܂B
	 * @param filename t@C
	 * @throws FileNotFoundException t@CJȂɓ܂B
	 */
	public void OpenFile(String filename) throws FileNotFoundException{
		Reader reader = new Reader();
		this.unsolvedData = reader.read(filename);
		this.useFixedOrder = reader.getUseFixedOrder();
		this.timelimit = reader.getTimeLimit();
		if(!useFixedOrder){ Shuffle(unsolvedData); }
		this.unsolvedPos = 0;
		this.historyData = new ArrayList();
		this.isInHistory = false;
		this.retryData = new ArrayList();
		this.fileName = removePath(filename);
		this.goodCounter = new ArrayList();
		this.goodCount = 0;
		badCount = 0;
		studying = true;
	}

	/**
	 * ̖󂯎܂B
	 * @return ̖BSInullB
	 */
	public Problem nextProblem(){
		if(isInHistory && historyPos < historyData.size()){
			Problem p = unsolvedData[historyPos];
			historyPos++;
			return p;
		}
		if(unsolvedData == null || unsolvedData.length <= unsolvedPos){
			int termgoodcount = unsolvedData.length - retryData.size();
			goodCounter.add(new Integer(termgoodcount));

			if(retryData == null || retryData.size() == 0){
				studying = false;
				return null;
			}else{
				unsolvedData = new Problem[retryData.size()];
				Iterator it = retryData.iterator();
				for(int i=0; i<retryData.size(); i++){
					unsolvedData[i] = (Problem)it.next();
				}
				retryData.clear();
				if(!useFixedOrder){ Shuffle(unsolvedData); }
				unsolvedPos = 0;
			}
		}
		Problem p = unsolvedData[unsolvedPos];
		unsolvedPos++;
		return p;
	}

	/**
	 * 萳ɌĂяoĂB
	 * @param problem 
	 * @param failed ꔭȂtrueAԈȂfalse
	 */
	public void solved(Problem problem, boolean failed){
		if(!isInHistory){
			historyData.add(problem);
			if(failed){
				retryData.add(problem);
				badCount++;
			}else{
				goodCount++;
			}
		}
	}
	
	/**
	 * c̖萔B
	 * FormɖnĂȂԂŌĂяoĂB
	 * isolvedsAnextProblemsOj
	 * @return c̖萔
	 */
	public int getRemainingCount(){
		int ret = 0;
		if(unsolvedData != null){
			ret += unsolvedData.length - unsolvedPos;
		}
		if(retryData != null){
			ret += retryData.size();
		}
		return ret;
	}

	/**
	 * pX܂܂ȂÃ݂t@CԂ܂B
	 * @return t@C
	 */
	public String getFileName(){
		return fileName;
	}

	/**
	 * ̐ڂ\AInteger̃XgԂ܂B
	 * @return e^[Ƃ̐i[ArrayList
	 */
	public ArrayList getGoodCounter(){
		return goodCounter;
	}

	/**
	 * ݂܂ł̐Ԃ܂B
	 * @return 
	 */
	public int getPercentage(){
		if(goodCount <= 0 && badCount <= 0){
			return 0;
		}
		return (goodCount * 100) / (goodCount + badCount);
	}
	
	/**
	 * z̗̓vf_ɕёւ܂B
	 * ͔̑jIłB
	 * @param arr
	 * ёւsz
	 * @return
	 * arrԂ܂B
	 */
	public static Object[] Shuffle(Object[] arr){
		for(int i=arr.length-1; i>=0; i--) {
			int j = rnd.nextInt(i+1);
			Object temp = arr[i];
			arr[i] = arr[j];
			arr[j] = temp;
		}
		return arr;
	}
	
	/**
	 * str1str2̓ꕔ̒Ԃ܂B
	 * @param str1 r镶
	 * @param str2 r镶
	 * @return v镔̒
	 */
	public static int hitLength(String str1, String str2){
		int i;
		for(i=0; i<str1.length() && i<str2.length(); i++){
			if(str1.charAt(i) != str2.charAt(i)){
				return i;
			}
		}
		return i;
	}
	
	/**
	 * o[W擾܂B
	 * @return o[W
	 */
	public static String getVersion(){
		return "Alpha 2005.03.29a";
	}
}
